import java.awt.Point;
import java.util.Scanner;
import static java.lang.System.out;

public class MazeGame {
  Maze maze;        // creates an instance variable storing our maze
  Point location;   // creates an instance variable that will store the users current location
  Scanner keyboard; // creates an instance variable that will monitor the keyboard input 
  
  MazeGame () {     // constructor method
    keyboard = new Scanner(System.in);    // initializes new Scanner
    
    maze = new Maze(5,5);         // initializes new Maze object 5 wide and 5 high
    
    location = new Point(0,0);    // creates the starting location for the user
    
    maze.setFinish(4,4);          // sets the finish point for the maze
    
    maze.addRoom(0,0);            // tells the maze object the user can move to the 0,0 position
    maze.addRoom(0,1);
    maze.addRoom(0,2);
    maze.addRoom(0,3);
    maze.addRoom(0,4);
    
    maze.addRoom(1,4);
    maze.addRoom(2,4);
    maze.addRoom(3,4);
    maze.addRoom(4,4);
  
    move();                       // calls the move method
  }
  
  public void move() {
      int x = (int)location.getX();   // get the current x location
      int y = (int)location.getY();   // get the current y location
      
      out.print("You may move");      
      if(x > 0) {                     // only allow people to move left if they're not at the left border of the maze
        if(maze.rooms[x - 1][y]) {
          out.print(" left");
        }
      }
      
      if(x < maze.width -1) {         // only allow people to move right if they're not at the right border
        if(maze.rooms[x + 1][y]) {
          out.print(" right");
        }
      }
      
      if(y > 0) {
        if(maze.rooms[x][y - 1]) {
            out.print(" up");
        }
      }
      
      if(y < maze.height - 1) {
        if(maze.rooms[x][y + 1]) {
            out.print(" down");
        }
      }
      
      out.println(". Which way do you go?");
      String dir = keyboard.next();             // get one word from the Scanner object, should be the direction the player wants to go
      
      if(dir.equals("left")) location.setLocation(x - 1, y);    // change the location (a Point object)
      if(dir.equals("right")) location.setLocation(x + 1, y);
      if(dir.equals("up")) location.setLocation(x, y - 1);
      if(dir.equals("down")) location.setLocation(x, y + 1);
      
      if(location.equals(maze.finish)) {                        // check and see if the current location equals the finish Point object
          out.println("***********\nYou've won!\n***********");
      }else{
        move();
      }
  }
}
